# Enum EntityQuery.Kind

java.lang.Object
java.lang.Enum<EntityQuery.Kind>
com.codename1.annotations.EntityQuery.Kind

All Implemented Interfaces:
  `Comparable<EntityQuery.Kind>`

Enclosing class:
  `EntityQuery`

public static enum EntityQuery.Kind extends Enum<EntityQuery.Kind>
The three lookups an entity type can offer.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BY_ID`
  `static T byId(String id)` -- resolve one instance from its `EntityId`.
  `SEARCH`
  `static List&lt;T&gt; matching(String query)` -- free-text lookup as the user types or speaks.
  `SUGGESTED`
  `static List&lt;T&gt; suggested()` -- the instances offered when the user is asked to choose.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static EntityQuery.Kind`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static EntityQuery.Kind[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, equals, getDeclaringClass, getEnumValues, hashCode, name, ordinal, setEnumValues, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### BY_ID

    public static final EntityQuery.Kind BY_ID
    `static T byId(String id)` -- resolve one instance from its `EntityId`. Mandatory for every entity type, because an entity crosses the platform boundary as its id and nothing else.

  - ### SUGGESTED

    public static final EntityQuery.Kind SUGGESTED
    `static List&lt;T&gt; suggested()` -- the instances offered when the user is asked to choose. This is what fills the platform's picker, so return the handful a person would plausibly want, not the whole table.

  - ### SEARCH

    public static final EntityQuery.Kind SEARCH
    `static List&lt;T&gt; matching(String query)` -- free-text lookup as the user types or speaks. Without it, a user can only pick from `SUGGESTED`.

- ## Method Details

  - ### values

    public static EntityQuery.Kind[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static EntityQuery.Kind valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null